from datetime import date

from pylim import lim

from oilanalytics.freight import route_consts


def lim_data(route: str, inc_fuels: bool = True, start_date: date = date(2010, 1, 1)):
    lim_series = {}

    ws_symbol = 'BALTIC.%s.TANKER.ROUTE.%s' % ('CLEAN' if route.lower().startswith('tc') else 'DIRTY', route.upper())
    if route == 'tc2':
        ws_symbol = 'TC2_BUILDUP'
    if route == 'tc3c':
        ws_symbol = 'TD3_BUILDUP'
    lim_series[ws_symbol] = 'WorldScale'
    fr_symbol = 'FREIGHT_%s_FLAT_RATE' % route.upper()
    lim_series[fr_symbol] = 'FlatRate'

    if inc_fuels:
        if route in route_consts.route_using_sing_fuels:
            fuels = route_consts.sing_fuels
        else:
            fuels = route_consts.rott_fuels
        lim_series = {**fuels, **lim_series}

    df = lim.series(lim_series, start_date=start_date)
    df['FlatRate'] = df['FlatRate'] * 100
    return df


if __name__ == '__main__':
    lim_data('tc2')